<?php
  /* ***** BEGIN LICENSE BLOCK *****
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License
   * Version 1.1 (the "MPL"); you may not use this file except in
   * compliance with the MPL. You may obtain a copy of the MPL at
   * http://www.mozilla.org/MPL/
   *
   * Software distributed under the MPL is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
   * for the specific language governing rights and limitations under the
   * MPL.
   *
   * The Original Code is Xplico Interface (XI).
   *
   * The Initial Developer of the Original Code is
   * Gianluca Costa <g.costa@xplico.org>
   * Portions created by the Initial Developer are Copyright (C) 2007
   * the Initial Developer. All Rights Reserved.
   *
   * Contributor(s):
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the GPL or the LGPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   *
   * ***** END LICENSE BLOCK ***** */

class PolsController extends AppController {
    var $name = 'Pols';
    var $helpers = array('Html', 'Form', 'Javascript');
    
    function beforeFilter() {
        $groupid = $this->Session->read('group');
        if (!$groupid) {
            $this->redirect('/users/login');
        }
        $this->Session->delete('pol');
        $this->Session->delete('sol');
    }
    
    function index() {
        $groupid = $this->Session->read('group');
        $this->Pol->recursive = -1;
        $this->set('pols', $this->Pol->findAll("group_id = $groupid", NULL, 'Pol.id DESC'));
        $this->set('menu_left', 
                   array('active' => '0', 'sections' => array(
                             array('name' => 'Case', 'sub' => array(
                                       array('name' => 'Cases', 'link' => '/pols'),
                                       array('name' => 'New Case', 'link' => '/pols/add')
                                       )
                                 )
                             )
                       )
            );
    }
    
    function view($id = null) {
        if (!$id) {
            $this->Session->setFlash('Invalid id for Case.');
            $this->redirect('/pols/index');
        }
        $this->Pol->recursive = -1;
        $pol = $this->Pol->read('group_id', $id);
        if ($pol['Pol']['group_id'] == $this->Session->read('group')) {
            $this->set('pol', $pol);
            $this->Session->write('pol', $id);
            // provvisorio
            $this->redirect('/sols/index');
        }
        else {
            $this->redirect('/pols/index');
        }
    }
    
    function add() {
        $this->set('menu_left', 
                   array('active' => '0', 'sections' => array(
                             array('name' => 'Case', 'sub' => array(
                                       array('name' => 'Cases', 'link' => '/pols'),
                                       array('name' => 'New Case', 'link' => '/pols/add')
                                       )
                                 )
                             )
                       )
            );
        if (!empty($this->data)) {
            //$this->cleanUpFields();  //Dprecated in Cake 1.2
            $value = $this->data['Capture']['Type'];
            $this->data['Pol']['realtime'] = $value;  //to-do: mix these two lines & probe it
            $groupid = $this->Session->read('group');
            $this->data['Pol']['group_id'] = $groupid; //to-do: mix these two lines & probe it
            if($this->Pol->save($this->data)) {
                $this->Session->setFlash('The Case has been created');
                $this->redirect('/pols/index');
            } else {
                $this->Session->setFlash('Please correct errors below.');
            }
            
        }
    }
    
    function delete($id = null) {
        if (!$id) {
            $this->Session->setFlash('Invalid id for Case');
            $this->redirect('/pols/index');
        }
        $this->Pol->recursive = -1;
        $pol = $this->Pol->read(null, $id);
        if ($pol['Pol']['group_id'] != $this->Session->read('group')) {
            $this->Session->setFlash('Invalid id for Case');
            $this->redirect('/pols/index');
        }
        // delete directory: send info to dema
        $pol_dir = '/opt/xplico/pol_'.$id;
        if (file_exists($pol_dir)) {
            /* exist at least one session */
            $del_pol_file = $pol_dir.'/delete';
            $fp = fopen($del_pol_file, 'aw');
            fclose($fp);
            // wait records db cancellation
            do {
                sleep(1);
            } while (file_exists($del_pol_file));
        }
        else {
            /* the case is only in the DB record */
            $this->Pol->delete($id);
        }
        $this->Session->setFlash('Case deleted');
        
        $this->redirect('/pols/index');
    }
}
?>